#include "StdAfx.h"
#include "Items.h"

typedef CItem* pCItem;

CItems::CItems(void)
{
	itemArray = new pCItem[35];
	length = 35;
	Count = 0;
}

CItems::~CItems(void)
{
	for (int loop = 0; loop < Count; loop++)
		delete itemArray[loop];

	delete[] itemArray;
}

void CItems::Sort()
{
	for (int loop = 0; loop < Count; loop++)
		itemArray[loop]->GetTransactionMask()->support = itemArray[loop]->GetTransactionMask()->CountElements();

	::qsort(itemArray, Count, sizeof(CItem *), rev_comp);

	itemsArrayHash.clear();
	for (int loop = 0; loop < Count; loop++)
		itemsArrayHash[itemArray[loop]->name] = loop;
}

int CItems::rev_comp(const void *p1, const void *p2)
{
	return (*((CItem **)p2))->GetTransactionMask()->support - (*((CItem **)p1))->GetTransactionMask()->support;
}

void CItems::AddItem(CItem *newItem)
{
	if (Count >= length)
	{
		CItem **newItemArray = new pCItem[length * 2];
		length = length * 2;
		::memcpy(newItemArray, itemArray, Count * sizeof(pCItem));
		delete[] itemArray;
		itemArray = newItemArray;
	}

	itemsArrayHash[newItem->name] = Count;
	itemArray[Count] = newItem;
	Count++;
}

int CItems::IndexOf(ITEM_NAME &s)
{
	hash_map <int, int> :: iterator pIter;

	pIter = itemsArrayHash.find(s);
	if ( pIter == itemsArrayHash.end( ) )
		return -1;

	return pIter->second;
/*
	itemsArrayHash[s];
	for (int loop = 0; loop < Count; loop++)
		if (itemArray[loop]->name == s)
			return loop;

	return -1;
*/
}
